<?php
/* Autor...: Grupo Deltron S.A. */
/* Esquema.: modelo_llamadas_nhc_5.xml */
/* Generado: 2014-11-25 12:54:18 */

/* Mantenimiento de los registros de la tabla cr_llamada_movimiento */
abstract class BaseCr_llamada_movimientoDP extends Cr_llamada_movimientoBN
{
    /* Constructor ( Establece los valores desde un objeto Cr_llamada_movimientoBN ) */
    public function __construct( Cr_llamada_movimientoBN $o_Cr_llamada_movimientoBN = null )
    {
        //parent::__construct();
        if ( !is_null( $o_Cr_llamada_movimientoBN ) )
        {
            $this->setByBN( $o_Cr_llamada_movimientoBN );
        }
    }

    /* Establece los valores desde un objeto Cr_llamada_movimientoBN */
    public function setByBN( Cr_llamada_movimientoBN $o_Cr_llamada_movimientoBN )
    {
        if ( !is_null( $o_Cr_llamada_movimientoBN->getIdMovimientoLlamada() ) )
        {
            $this->setIdMovimientoLlamada( $o_Cr_llamada_movimientoBN->getIdMovimientoLlamada() );
        }
        if ( !is_null( $o_Cr_llamada_movimientoBN->getIdCabecera() ) )
        {
            $this->setIdCabecera( $o_Cr_llamada_movimientoBN->getIdCabecera() );
        }
        if ( !is_null( $o_Cr_llamada_movimientoBN->getIdTelefono() ) )
        {
            $this->setIdTelefono( $o_Cr_llamada_movimientoBN->getIdTelefono() );
        }
        if ( !is_null( $o_Cr_llamada_movimientoBN->getIdCliente() ) )
        {
            $this->setIdCliente( $o_Cr_llamada_movimientoBN->getIdCliente() );
        }
        if ( !is_null( $o_Cr_llamada_movimientoBN->getIdResultado() ) )
        {
            $this->setIdResultado( $o_Cr_llamada_movimientoBN->getIdResultado() );
        }
        if ( !is_null( $o_Cr_llamada_movimientoBN->getDetalle() ) )
        {
            $this->setDetalle( $o_Cr_llamada_movimientoBN->getDetalle() );
        }
        if ( !is_null( $o_Cr_llamada_movimientoBN->getFecha() ) )
        {
            $this->setFecha( $o_Cr_llamada_movimientoBN->getFecha() );
        }
        if ( !is_null( $o_Cr_llamada_movimientoBN->getMonto() ) )
        {
            $this->setMonto( $o_Cr_llamada_movimientoBN->getMonto() );
        }
        if ( !is_null( $o_Cr_llamada_movimientoBN->getHoraMinutoFin() ) )
        {
            $this->setHoraMinutoFin( $o_Cr_llamada_movimientoBN->getHoraMinutoFin() );
        }
        if ( !is_null( $o_Cr_llamada_movimientoBN->getHoraMinutoInicio() ) )
        {
            $this->setHoraMinutoInicio( $o_Cr_llamada_movimientoBN->getHoraMinutoInicio() );
        }
        if ( !is_null( $o_Cr_llamada_movimientoBN->getTipoPago() ) )
        {
            $this->setTipoPago( $o_Cr_llamada_movimientoBN->getTipoPago() );
        }
        if ( !is_null( $o_Cr_llamada_movimientoBN->getBanco() ) )
        {
            $this->setBanco( $o_Cr_llamada_movimientoBN->getBanco() );
        }
        if ( !is_null( $o_Cr_llamada_movimientoBN->getEstado() ) )
        {
            $this->setEstado( $o_Cr_llamada_movimientoBN->getEstado() );
        }
        if ( !is_null( $o_Cr_llamada_movimientoBN->getFechaRegistro() ) )
        {
            $this->setFechaRegistro( $o_Cr_llamada_movimientoBN->getFechaRegistro() );
        }
        if ( !is_null( $o_Cr_llamada_movimientoBN->getUsuarioRegistro() ) )
        {
            $this->setUsuarioRegistro( $o_Cr_llamada_movimientoBN->getUsuarioRegistro() );
        }
        if ( !is_null( $o_Cr_llamada_movimientoBN->getEliminado() ) )
        {
            $this->setEliminado( $o_Cr_llamada_movimientoBN->getEliminado() );
        }
        if ( !is_null( $o_Cr_llamada_movimientoBN->getFechaEliminado() ) )
        {
            $this->setFechaEliminado( $o_Cr_llamada_movimientoBN->getFechaEliminado() );
        }
        if ( !is_null( $o_Cr_llamada_movimientoBN->getUsuarioEliminado() ) )
        {
            $this->setUsuarioEliminado( $o_Cr_llamada_movimientoBN->getUsuarioEliminado() );
        }
    }

    /* Graba un nuevo registro */
    public function save()
    {
        //$this->validateRecord();
        $o_cr_llamada_movimientoFN = new Cr_llamada_movimientoFN();
        $o_cr_llamada_movimientoBN = $o_cr_llamada_movimientoFN->selectByPk( $this->getIdMovimientoLlamada() );
        if ( is_null( $o_cr_llamada_movimientoBN ) )
        {
            $s_SQLQuery1 = "INSERT INTO cr_llamada_movimiento ( ";
            $s_SQLQuery2 = "VALUES ( ";
            $s_Separator = "";
            if ( !is_null( $this->getIdMovimientoLlamada() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdMovimientoLlamada";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdMovimientoLlamada()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdCabecera() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdCabecera";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdCabecera()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdTelefono() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdTelefono";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdTelefono()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdCliente() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdCliente";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdCliente()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdResultado() ) )
            {
                $s_SQLQuery1 .= $s_Separator."IdResultado";
                $s_SQLQuery2 .= $s_Separator."".$this->getIdResultado()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getDetalle() ) )
            {
                $s_SQLQuery1 .= $s_Separator."Detalle";
                $s_SQLQuery2 .= $s_Separator."'".$this->getDetalle()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFecha() ) )
            {
                $s_SQLQuery1 .= $s_Separator."Fecha";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFecha()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getMonto() ) )
            {
                $s_SQLQuery1 .= $s_Separator."Monto";
                $s_SQLQuery2 .= $s_Separator."'".$this->getMonto()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getHoraMinutoFin() ) )
            {
                $s_SQLQuery1 .= $s_Separator."HoraMinutoFin";
                $s_SQLQuery2 .= $s_Separator."'".$this->getHoraMinutoFin()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getHoraMinutoInicio() ) )
            {
                $s_SQLQuery1 .= $s_Separator."HoraMinutoInicio";
                $s_SQLQuery2 .= $s_Separator."'".$this->getHoraMinutoInicio()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getTipoPago() ) )
            {
                $s_SQLQuery1 .= $s_Separator."TipoPago";
                $s_SQLQuery2 .= $s_Separator."'".$this->getTipoPago()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getBanco() ) )
            {
                $s_SQLQuery1 .= $s_Separator."Banco";
                $s_SQLQuery2 .= $s_Separator."'".$this->getBanco()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getEstado() ) )
            {
                $s_SQLQuery1 .= $s_Separator."Estado";
                $s_SQLQuery2 .= $s_Separator."'".$this->getEstado()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaRegistro() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaRegistro";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaRegistro()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioRegistro() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UsuarioRegistro";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUsuarioRegistro()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getEliminado() ) )
            {
                $s_SQLQuery1 .= $s_Separator."Eliminado";
                $s_SQLQuery2 .= $s_Separator."".$this->getEliminado()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaEliminado() ) )
            {
                $s_SQLQuery1 .= $s_Separator."FechaEliminado";
                $s_SQLQuery2 .= $s_Separator."'".$this->getFechaEliminado()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioEliminado() ) )
            {
                $s_SQLQuery1 .= $s_Separator."UsuarioEliminado";
                $s_SQLQuery2 .= $s_Separator."'".$this->getUsuarioEliminado()."'";
                $s_Separator = ", ";
            }
            $s_SQLQuery = $s_SQLQuery1." ) ".$s_SQLQuery2." );";
            $o_Resource = $o_cr_llamada_movimientoFN->getConnect();
            //echo $s_SQLQuery;
            $o_Result = mysql_query( $s_SQLQuery, $o_Resource );
            if ( $o_Result === false )
            {
                throw new Exception( mysql_error() );
            }
        }
        else
        {
            throw new Exception( "El id ya esta registrado." );
        }
        return true;
    }

    /* Actualiza los datos del registro */
    public function update()
    {
        //$this->validateRecord();
        $o_cr_llamada_movimientoFN = new Cr_llamada_movimientoFN();
        $o_cr_llamada_movimientoBN = $o_cr_llamada_movimientoFN->selectByPk( $this->getIdMovimientoLlamada() );
        if ( !is_null( $o_cr_llamada_movimientoBN ) )
        {
            $s_SQLQuery = "UPDATE cr_llamada_movimiento SET ";
            $s_Separator = "";
            if ( !is_null( $this->getIdCabecera() ) && $this->getIdCabecera() !== $o_cr_llamada_movimientoBN->getIdCabecera() )
            {
                $s_SQLQuery .= $s_Separator."IdCabecera = ".$this->getIdCabecera()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdTelefono() ) && $this->getIdTelefono() !== $o_cr_llamada_movimientoBN->getIdTelefono() )
            {
                $s_SQLQuery .= $s_Separator."IdTelefono = ".$this->getIdTelefono()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdCliente() ) && $this->getIdCliente() !== $o_cr_llamada_movimientoBN->getIdCliente() )
            {
                $s_SQLQuery .= $s_Separator."IdCliente = ".$this->getIdCliente()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getIdResultado() ) && $this->getIdResultado() !== $o_cr_llamada_movimientoBN->getIdResultado() )
            {
                $s_SQLQuery .= $s_Separator."IdResultado = ".$this->getIdResultado()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getDetalle() ) && $this->getDetalle() !== $o_cr_llamada_movimientoBN->getDetalle() )
            {
                $s_SQLQuery .= $s_Separator."Detalle = '".$this->getDetalle()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFecha() ) && $this->getFecha() !== $o_cr_llamada_movimientoBN->getFecha() )
            {
                $s_SQLQuery .= $s_Separator."Fecha = '".$this->getFecha()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getMonto() ) && $this->getMonto() !== $o_cr_llamada_movimientoBN->getMonto() )
            {
                $s_SQLQuery .= $s_Separator."Monto = ".$this->getMonto()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getHoraMinutoFin() ) && $this->getHoraMinutoFin() !== $o_cr_llamada_movimientoBN->getHoraMinutoFin() )
            {
                $s_SQLQuery .= $s_Separator."HoraMinutoFin = ".$this->getHoraMinutoFin()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getHoraMinutoInicio() ) && $this->getHoraMinutoInicio() !== $o_cr_llamada_movimientoBN->getHoraMinutoInicio() )
            {
                $s_SQLQuery .= $s_Separator."HoraMinutoInicio = ".$this->getHoraMinutoInicio()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getTipoPago() ) && $this->getTipoPago() !== $o_cr_llamada_movimientoBN->getTipoPago() )
            {
                $s_SQLQuery .= $s_Separator."TipoPago = '".$this->getTipoPago()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getBanco() ) && $this->getBanco() !== $o_cr_llamada_movimientoBN->getBanco() )
            {
                $s_SQLQuery .= $s_Separator."Banco = '".$this->getBanco()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getEstado() ) && $this->getEstado() !== $o_cr_llamada_movimientoBN->getEstado() )
            {
                $s_SQLQuery .= $s_Separator."Estado = '".$this->getEstado()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaRegistro() ) && $this->getFechaRegistro() !== $o_cr_llamada_movimientoBN->getFechaRegistro() )
            {
                $s_SQLQuery .= $s_Separator."FechaRegistro = '".$this->getFechaRegistro()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioRegistro() ) && $this->getUsuarioRegistro() !== $o_cr_llamada_movimientoBN->getUsuarioRegistro() )
            {
                $s_SQLQuery .= $s_Separator."UsuarioRegistro = '".$this->getUsuarioRegistro()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getEliminado() ) && $this->getEliminado() !== $o_cr_llamada_movimientoBN->getEliminado() )
            {
                $s_SQLQuery .= $s_Separator."Eliminado = ".$this->getEliminado()."";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getFechaEliminado() ) && $this->getFechaEliminado() !== $o_cr_llamada_movimientoBN->getFechaEliminado() )
            {
                $s_SQLQuery .= $s_Separator."FechaEliminado = '".$this->getFechaEliminado()."'";
                $s_Separator = ", ";
            }
            if ( !is_null( $this->getUsuarioEliminado() ) && $this->getUsuarioEliminado() !== $o_cr_llamada_movimientoBN->getUsuarioEliminado() )
            {
                $s_SQLQuery .= $s_Separator."UsuarioEliminado = '".$this->getUsuarioEliminado()."'";
                $s_Separator = ", ";
            }
            $s_SQLQuery .= " WHERE  IdMovimientoLlamada = ".$this->getIdMovimientoLlamada().";";
            $o_Resource = $o_cr_llamada_movimientoFN->getConnect();
            if ( mysql_query( $s_SQLQuery, $o_Resource ) === false )
            {
                throw new Exception( mysql_error() );
            }
        }
        else
        {
            throw new Exception( "El id no esta registrado." );
        }
        return true;
    }

    /* Elimina el registro */
    public function delete()
    {
        $o_cr_llamada_movimientoFN = new Cr_llamada_movimientoFN();
        $o_cr_llamada_movimientoBN = $o_cr_llamada_movimientoFN->selectByPk( $this->getIdMovimientoLlamada() );
        if ( !is_null( $o_cr_llamada_movimientoBN ) )
        {
            $s_SQLQuery = "DELETE FROM cr_llamada_movimiento WHERE  IdMovimientoLlamada = ".$this->getIdMovimientoLlamada().";";
            $o_Resource = $o_cr_llamada_movimientoFN->getConnect();
            if ( mysql_query( $s_SQLQuery, $o_Resource ) === false )
            {
                throw new Exception( mysql_error() );
            }
        }
        else
        {
            throw new Exception( "El id no esta registrado." );
        }
        return true;
    }

    /* Selecciona un registro por la llave primaria */
    public static function selectByPk( $i_IdMovimientoLlamada )
    {
        $o_cr_llamada_movimientoFN = new Cr_llamada_movimientoFN();
        if ( $o_cr_llamada_movimientoBN = $o_cr_llamada_movimientoFN->selectByPK( $i_IdMovimientoLlamada ) )
        {
            $o_cr_llamada_movimientoDP = new cr_llamada_movimientoDP();
            $o_cr_llamada_movimientoDP->setIdMovimientoLlamada( $o_cr_llamada_movimientoBN->getIdMovimientoLlamada(), false );
            $o_cr_llamada_movimientoDP->setIdCabecera( $o_cr_llamada_movimientoBN->getIdCabecera(), false );
            $o_cr_llamada_movimientoDP->setIdTelefono( $o_cr_llamada_movimientoBN->getIdTelefono(), false );
            $o_cr_llamada_movimientoDP->setIdCliente( $o_cr_llamada_movimientoBN->getIdCliente(), false );
            $o_cr_llamada_movimientoDP->setIdResultado( $o_cr_llamada_movimientoBN->getIdResultado(), false );
            $o_cr_llamada_movimientoDP->setDetalle( $o_cr_llamada_movimientoBN->getDetalle(), false );
            $o_cr_llamada_movimientoDP->setFecha( $o_cr_llamada_movimientoBN->getFecha(), false );
            $o_cr_llamada_movimientoDP->setMonto( $o_cr_llamada_movimientoBN->getMonto(), false );
            $o_cr_llamada_movimientoDP->setHoraMinutoFin( $o_cr_llamada_movimientoBN->getHoraMinutoFin(), false );
            $o_cr_llamada_movimientoDP->setHoraMinutoInicio( $o_cr_llamada_movimientoBN->getHoraMinutoInicio(), false );
            $o_cr_llamada_movimientoDP->setTipoPago( $o_cr_llamada_movimientoBN->getTipoPago(), false );
            $o_cr_llamada_movimientoDP->setBanco( $o_cr_llamada_movimientoBN->getBanco(), false );
            $o_cr_llamada_movimientoDP->setEstado( $o_cr_llamada_movimientoBN->getEstado(), false );
            $o_cr_llamada_movimientoDP->setFechaRegistro( $o_cr_llamada_movimientoBN->getFechaRegistro(), false );
            $o_cr_llamada_movimientoDP->setUsuarioRegistro( $o_cr_llamada_movimientoBN->getUsuarioRegistro(), false );
            $o_cr_llamada_movimientoDP->setEliminado( $o_cr_llamada_movimientoBN->getEliminado(), false );
            $o_cr_llamada_movimientoDP->setFechaEliminado( $o_cr_llamada_movimientoBN->getFechaEliminado(), false );
            $o_cr_llamada_movimientoDP->setUsuarioEliminado( $o_cr_llamada_movimientoBN->getUsuarioEliminado(), false );
        }
        else
        {
            throw new Exception( "El id no esta registrado." );
        }
        return $o_cr_llamada_movimientoDP;
    }
}
?>